
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

(************************** Royale PlatForm Engine ***************************

fond.pcx     : Image 320*177*84  couleurs
sprites.pcx  : Image 320*200*168 couleurs dont la 1ere couleur est transparente
Les 4 couleurs restantes sont pour le fond noir et le texte...
Ecran de jeu : 304*176

Gestion XMS : Sons & Videos...
Partir du principe qu'il y a beaucoup de RAM car le jeu ne tournera jamais sur
petite configuration !!!

*****************************************************************************)


program cubitus_game;
uses platkeys,mode13,pcx,xms,sound,avi,crt;
const lf_rol=[8..10];
      rg_rol=[28..30];
      climb=[49..51];
      jump_blk=[7];
      up_blk=[48,106,125..127,  68, 89,109,129, 52..59,72..79,92..99,112..119,132..139]+lf_rol+rg_rol+jump_blk;
      dw_blk=[48,106,125..127,  88, 69,109,129, 52..59,72..79,92..99,112..119,132..139]+lf_rol+rg_rol+jump_blk;
      lf_blk=[48,106,125..127, 128, 69, 89,109, 52..59,72..79,92..99,112..119,132..139]+lf_rol+rg_rol+jump_blk;
      rg_blk=[48,106,125..127, 108, 69, 89,129, 52..59,72..79,92..99,112..119,132..139]+lf_rol+rg_rol+jump_blk;
      exit_blk=[70,71,90,91,110,111,130,131];
      kill_blk=[69,89,109,129];
      xsize=30;    (*hauteur du monsieur*)
      ysize=47;    (*largeur du monsieur*)
      trnscol=0;
      fondcol=253;
      textcol=254;
      waitpix=300; (*nombre d'images avant pose*)
      shit_spe=5;

var niv_ptr,make_pg,temp_pg,fond_pg,sprt_pg:pointer;   (*pointeurs de pages virtuelles.*)
    ecran:record x,y:real; end;
    cubitus:record x,y,xspe,yspe:real; saut,monter,dir:boolean; life,ups:byte; wait:word; anim:byte; end;
    objet:array [1..300] of record typ,xsize,ysize:byte; x,y,xspe:real; exist:boolean; end;
    nb_obj,i,j:word;
    level,bless,cmpt_anims:byte;
    bigend,finished,shit,engine_in_screen,demi,half:boolean;

    header:record
      name:string[26];
      xmax,ymax:word;
      fond,sprites:string[12];
      X_scroll,Y_scroll:boolean;
      run_spe,climb_spe,rol_acc,run_acc,gravity,inertie,reb_sol,reb_pfd,reb_mur,reb_jmp,x_anticip,y_anticip:real;
      xdeb,ydeb:word;
    end;

    nomansux:record
      ok,diry:boolean;
      posy:word;
    end;

    BigXMS:fileXMS;

    vid:record
      noman,theend,
      royale:fileXMS;
    end;
    wav:record
      dommage,theend,
      boing,pop,dead,minou,
      sux,clap,
      engine,
      shit,ups:fileXMS;
      aie:array [1..3] of fileXMS;
    end;

{$i info.inc}
{$i initclos.inc}

procedure boxtext(texte:string);
begin
  clearpage(temp_pg);
  for i:=4 to 15 do for j:=4 to 8 do
    if (i=4) or (i=15) or (j=4) or (j=8) then copyblock(16,16,sprt_pg,96,96,temp_pg,i*16,j*16,true,false);
  outtextxy(temp_pg,160-length(texte)*3,95,texte,textcol,trnscol);
  outtextxy(temp_pg,103,106,'PRESS ENTER KEY !!!',textcol,trnscol);
  copypage(temp_pg,scrn_pg);
  repeat until not entree;
  repeat until entree;
  clearpage(temp_pg);
end;

function niv(i,j:word):byte;
begin
  niv:=mem[seg(niv_ptr^):j*header.xmax+i];
end;

function loadniv:boolean;
var fic:file;
    filename:string;
begin
  loadniv:=false;
  inc(level);
  str(level,filename);
  filename:='levels\story.'+filename;
  assign(fic,filename);
  reset(fic,1);
  if ioresult<>0 then exit;
  blockread(fic,header,sizeof(header));
  blockread(fic,niv_ptr^,header.xmax*header.ymax);
  close(fic);
  loadpcx('pix\'+header.sprites,sprt_pg,0,168-1);
  if header.fond='' then clearpage(fond_pg)
  else loadpcx('pix\'+header.fond,fond_pg,169,84-1);
  pal[0]:=0;
  pal[1]:=0;
  pal[2]:=0;
  setpal;
  finished:=false;
  nb_obj:=0;
  for i:=0 to header.xmax-1 do for j:=0 to header.ymax-1 do
  if niv(i,j) in [120..122] then begin
    inc(nb_obj);
    with objet[nb_obj] do begin
      case niv(i,j) of
        120:begin xsize:=31; ysize:=32; typ:=1; xspe:=random(100)/100+1.5; end;
        121:begin xsize:=16; ysize:=16; typ:=2; xspe:=0; end;
        122:begin xsize:=16; ysize:=7;  typ:=3; xspe:=0; end;
      end;
      x:=i*16; y:=(j+1)*16-ysize;
      exist:=true;
    end;
    mem[seg(niv_ptr^):j*header.xmax+i]:=0;
  end;
  boxtext(header.name);
  loadniv:=true;
end;

procedure reload;
begin
  with cubitus do begin
    x:=header.xdeb;
    y:=header.ydeb;
    xspe:=0;
    yspe:=0;
    life:=120;
  end;
  for i:=1 to nb_obj do if objet[i].typ<>3 then objet[i].exist:=true;
end;

procedure make_screen;
var xr,yr:word;
begin

  clearpage(temp_pg);

(*image de fond 320*176 en 2 morceaux*)
  xr:=trunc(ecran.x);
  yr:=trunc(ecran.y);
  if header.Y_scroll then
    if header.X_scroll then begin
      copyblock(304,yr mod 352 div 2,fond_pg,xr mod 640 div 2,0,temp_pg,8,8+176-yr mod 352 div 2,true,false);
      copyblock(304,176-yr mod 352 div 2,fond_pg,xr mod 640 div 2,yr mod 352 div 2,temp_pg,8,8,true,false);
    end else begin
      copyblock(304,yr mod 352 div 2,fond_pg,0,0,temp_pg,8,8+176-yr mod 352 div 2,true,false);
      copyblock(304,176-yr mod 352 div 2,fond_pg,0,yr mod 352 div 2,temp_pg,8,8,true,false);
    end;
  if not header.Y_scroll then begin
    if header.X_scroll then
      copyblock(304,176,fond_pg,xr mod 640 div 2,0,temp_pg,8,8,true,false)
    else
      copyblock(304,176,fond_pg,0,0,temp_pg,8,8,true,false);
  end;

(*gnration des briques*)
  engine_in_screen:=false;
  for i:=0 to 19 do for j:=0 to 11 do
  if (i+xr div 16<header.xmax) and (j+yr div 16<header.ymax) then begin
    if niv(i+xr div 16,j+yr div 16) in lf_rol+rg_rol then begin
      engine_in_screen:=true;
      copyblock(16,16,sprt_pg,(niv(i+xr div 16,j+yr div 16)+cmpt_anims mod 4*3) mod 20*16,
      (niv(i+xr div 16,j+yr div 16)+cmpt_anims mod 4*3) div 20*16,make_pg,i*16,j*16,true,false)
    end
    else
      copyblock(16,16,sprt_pg,niv(i+xr div 16,j+yr div 16) mod 20*16,
      niv(i+xr div 16,j+yr div 16) div 20*16,make_pg,i*16,j*16,true,false);
  end;
  if engine_in_screen then play_wav(wav.engine,50)
  else if current.playing and (current.priority=50) then begin
    dmastop;
    current.playing:=false;
  end;

(*copie des briques sur le fond avec dcalage voulu en transparence*)
  copyblock(304,176,make_pg,xr mod 16,yr mod 16,temp_pg,8,8,false,false);

(*Objets !*)
  for i:=1 to nb_obj do with objet[i] do if exist
   and (trunc(x)-xr+8>=8) and (trunc(x)-xr<=304-xsize)
   and (trunc(y)-yr+8>=8) and (trunc(y)-yr<=176-ysize) then
    case typ of
      1:case (cmpt_anims div 16) mod 4 of
          0,2:copyblock(31,32,sprt_pg,32,161,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8,false,xspe<0);
            1:copyblock(31,32,sprt_pg,0,161,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8,false,xspe<0);
            3:copyblock(31,32,sprt_pg,64,161,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8,false,xspe<0);
        end;
      2:copyblock(16,16,sprt_pg,16,96,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8,false,false);
      3:copyblock(16,7,sprt_pg,32,105,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8,false,false);
    end;

(*Cubitus...*)
  with cubitus do begin
    if life=0 then begin
      copyblock(29,25,sprt_pg,96,161,temp_pg,trunc(x)-xr+8+20,trunc(y)-yr+8+4,false,false);
      copyblock(29,25,sprt_pg,96,161,temp_pg,trunc(x)-xr+8-20,trunc(y)-yr+8+4,false,true);
      copyblock(xsize,ysize,sprt_pg,93,113,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8
                ,false,not(dir));
    end else
    if shit then
      copyblock(72,ysize,sprt_pg,155,113,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8
                ,false,not(dir))
    else
    if wait=waitpix then
      copyblock(xsize,ysize,sprt_pg,93,113,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8
                ,false,not(dir))
    else if monter then case (anim div 16) mod 2 of
      0:copyblock(xsize,ysize,sprt_pg,124,113,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8
                    ,false,false);
      1:copyblock(xsize,ysize,sprt_pg,124,113,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8
                    ,false,true);
    end else
    case (anim div 16) mod 4 of
         0:copyblock(xsize,ysize,sprt_pg, 0,113,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8
                    ,false,not(dir));
         2:copyblock(xsize,ysize,sprt_pg,62,113,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8
                    ,false,not(dir));
        1,3:copyblock(xsize,ysize,sprt_pg,31,113,temp_pg,trunc(x)-xr+8,trunc(y)-yr+8
                    ,false,not(dir));
    end;
    outtextxy(temp_pg,8,190,'CUBITUS GAME.',textcol,trnscol);
    for i:=1 to ups-1 do copyblock(16,7,sprt_pg,32,105,temp_pg,70+i*20,190,false,false);
    copyblock(life,7,sprt_pg,0,193,temp_pg,192,190,true,false);
  end;

  with nomansux do begin
    if ok then begin
      copyblock(78,posy,sprt_pg,242,113,temp_pg,242,200-posy,false,false);
      if diry then begin
        if not (current.playing and (current.priority=255)) then dec(posy)
      end
      else inc(posy);
      if (posy=87) and not (current.playing and (current.priority=255)) then begin
        diry:=true;
        play_wav(wav.sux,255);
      end;
      if posy=0 then begin
        ok:=false;
        diry:=false;
      end;
    end;
  end;
end;

procedure vies(k:real);
begin
  if k<0 then
    if cubitus.life+k>0 then begin
      play_wav(wav.aie[random(3)+1],60);
      inc(cubitus.life,round(k));
    end
    else begin
      play_wav(wav.dead,61);
      cubitus.life:=0;
    end;
  if (k>0) and (cubitus.life<>120) then begin
    if cubitus.life+k<=120 then inc(cubitus.life,round(k))
                          else cubitus.life:=120;
    play_wav(wav.shit,59);
  end;
end;

procedure move_objets;
begin
  for i:=1 to nb_obj do with objet[i] do begin
    if (xspe<0)
   and not (niv(trunc(x+xspe) div 16,trunc(y+32) div 16) in dw_blk)
    or (xspe>0)
   and not (niv(trunc(x+xspe+32) div 16,trunc(y+32) div 16) in dw_blk)
  then xspe:=-xspe;
    x:=x+xspe;
  end;
end;

procedure move_cubitus;
begin
  with cubitus do begin

    if shit then begin
      if up    then if y>shit_spe then y:=y-shit_spe else y:=0;
      if down  then if y+ysize<header.ymax*16-shit_spe-1 then y:=y+shit_spe else y:=header.ymax*16-ysize-1;
      if left  then begin
        if x>shit_spe then x:=x-shit_spe else x:=0;
        dir:=false;
      end;
      if right then begin
        if x+72<header.xmax*16-shit_spe then x:=x+shit_spe else x:=header.xmax*16-72;
        dir:=true;
      end;
    end else begin

(*gestion de l'animation*)
    if (monter and (up or down)) or (left or right) then begin
      wait:=0;
      inc(anim);
    end else
    if not monter then begin
      anim:=16;
      if wait<>waitpix then inc(wait);
    end;

(*gestion des acclrations*)
    if left then begin
      if (xspe>-header.run_spe) then xspe:=xspe-header.run_spe*header.run_acc;
      dir:=false;
    end else
    if right then begin
      if (xspe<header.run_spe) then xspe:=xspe+header.run_spe*header.run_acc;
      dir:=true;
    end else begin
      if xspe> header.run_spe*header.inertie then xspe:=xspe-header.run_spe*header.inertie else
      if xspe<-header.run_spe*header.inertie then xspe:=xspe+header.run_spe*header.inertie else xspe:=0;
    end;

(*gestion des tapis roulants*)
  if ( (niv(trunc(x+xspe) div 16,trunc(y+ysize+yspe+4) div 16) in lf_rol)
    or (niv(trunc(x+xspe+16) div 16,trunc(y+ysize+yspe+4) div 16) in lf_rol)
    or (niv(trunc(x+xspe+xsize) div 16,trunc(y+ysize+yspe+4) div 16) in lf_rol) )
    then if xspe<header.run_spe then xspe:=xspe+header.run_spe*header.rol_acc;
  if ( (niv(trunc(x+xspe) div 16,trunc(y+ysize+yspe+4) div 16) in rg_rol)
    or (niv(trunc(x+xspe+16) div 16,trunc(y+ysize+yspe+4) div 16) in rg_rol)
    or (niv(trunc(x+xspe+xsize) div 16,trunc(y+ysize+yspe+4) div 16) in rg_rol) )
    then if xspe>-header.run_spe then xspe:=xspe-header.run_spe*header.rol_acc;

(*gestion des colisions faciales*)
    if ( (xspe<0) and
     ( (niv(trunc(x+xspe) div 16,trunc(y) div 16) in lf_blk)
    or (niv(trunc(x+xspe) div 16,trunc(y+16) div 16) in lf_blk)
    or (niv(trunc(x+xspe) div 16,trunc(y+32) div 16) in lf_blk)
    or (niv(trunc(x+xspe) div 16,trunc(y+ysize-1) div 16) in lf_blk) )
    or (x+xspe<0) )
    or ( (xspe>0) and
     ( (niv(trunc(x+xspe+xsize) div 16,trunc(y) div 16) in rg_blk)
    or (niv(trunc(x+xspe+xsize) div 16,trunc(y+16) div 16) in rg_blk)
    or (niv(trunc(x+xspe+xsize) div 16,trunc(y+32) div 16) in rg_blk)
    or (niv(trunc(x+xspe+xsize) div 16,trunc(y+ysize-1) div 16) in rg_blk) )
    or (x+xspe+xsize>header.xmax*16) )
    then xspe:=-header.reb_mur*xspe;

    if (yspe<header.run_spe*2) then yspe:=yspe+header.run_spe/50*header.gravity;
    if yspe>header.run_spe then inc(bless,round(yspe/2)) else bless:=0;

(*gestion des echelles*)
   if (niv(trunc(x+xspe) div 16,trunc(y+yspe) div 16) in climb)
  and (niv(trunc(x+xspe+xsize) div 16,trunc(y+yspe) div 16) in climb)
    then begin
      if monter then yspe:=0;
      if up then begin
        yspe:=-header.climb_spe;
        monter:=true;
      end;
      if down then yspe:=header.climb_spe;
    end else monter:=false;

(*gestion des plafonds*)
    if (yspe<0)
    and ( (niv(trunc(x+xspe) div 16,trunc(y+yspe) div 16) in up_blk)
     or (niv(trunc(x+xspe+16) div 16,trunc(y+yspe) div 16) in up_blk)
     or (niv(trunc(x+xspe+xsize) div 16,trunc(y+yspe) div 16) in up_blk)
     or (y+yspe<0) )
    then begin
      if yspe<-header.run_spe then vies(2*yspe);
      yspe:=-header.reb_pfd*yspe
    end else y:=y+yspe;

    if yspe>0 then saut:=false;
    if saut and not up then begin saut:=false; yspe:=0.7*yspe;
    end;

(*gestion des trampolines*)
    if (yspe>0) and
      ( (niv(trunc(x+xspe) div 16,trunc(y+ysize+yspe) div 16) in jump_blk)
     or (niv(trunc(x+xspe+16) div 16,trunc(y+ysize+yspe) div 16) in jump_blk)
     or (niv(trunc(x+xspe+xsize) div 16,trunc(y+ysize+yspe) div 16) in jump_blk) )
    then begin
      y:=trunc(y+yspe+ysize) div 16*16-ysize;
      yspe:=-header.reb_jmp*yspe;
      if up then begin
        play_wav(wav.boing,20);
        saut:=true;
        yspe:=yspe-header.run_spe/header.gravity;
      end;
    end;

(*gestion des morts par chute hors de l'cran*)
    if (yspe>0) and (y+yspe+ysize+1>=header.ymax*16) then vies(-life);

(*gestion des sols*)
    if (yspe>0) and
     ( (niv(trunc(x+xspe) div 16,trunc(y+ysize+yspe) div 16) in dw_blk)
    or (niv(trunc(x+xspe+16) div 16,trunc(y+ysize+yspe) div 16) in dw_blk)
    or (niv(trunc(x+xspe+xsize) div 16,trunc(y+ysize+yspe) div 16) in dw_blk) )
    then begin
      y:=trunc(y+yspe+ysize) div 16*16-ysize;
      yspe:=-header.reb_sol*yspe;
      vies(-bless);
      if up then begin
        play_wav(wav.pop,20);
        saut:=true;
        yspe:=-header.run_spe/header.gravity;
      end;
    end;

    x:=x+xspe;

(*gestion des objets*)
  for i:=1 to nb_obj do if objet[i].exist
 and (trunc(x)+xsize>objet[i].x)
 and (trunc(x)<objet[i].x+objet[i].xsize)
 and (trunc(y)+ysize>objet[i].y)
 and (trunc(y)<objet[i].y+objet[i].ysize) then
 case objet[i].typ of
   1:if (trunc(y)+ysize-9<=objet[i].y) and (yspe>0)
     then begin
       play_wav(wav.minou,70);
       yspe:=-header.reb_sol*yspe;
       objet[i].exist:=false;
     end else vies(-1);
   2:if life<>120 then begin
       vies(+10);
       objet[i].exist:=false;
     end;
   3:if ups<6 then begin
       play_wav(wav.ups,99);
       inc(ups);
       objet[i].exist:=false;
     end;
 end;

(*gestion des blocs qui tuent !!!*)
    if (niv(trunc(x) div 16,trunc(y) div 16) in kill_blk)
    or (niv(trunc(x+16) div 16,trunc(y) div 16) in kill_blk)
    or (niv(trunc(x+xsize) div 16,trunc(y) div 16) in kill_blk)
    or (niv(trunc(x) div 16,trunc(y+ysize-1) div 16) in kill_blk)
    or (niv(trunc(x+16) div 16,trunc(y+ysize-1) div 16) in kill_blk)
    or (niv(trunc(x+xsize) div 16,trunc(y+ysize-1) div 16) in kill_blk)
    or (niv(trunc(x) div 16,trunc(y+16) div 16) in kill_blk)
    or (niv(trunc(x) div 16,trunc(y+32) div 16) in kill_blk)
    or (niv(trunc(x+xsize) div 16,trunc(y+16) div 16) in kill_blk)
    or (niv(trunc(x+xsize) div 16,trunc(y+32) div 16) in kill_blk)
    then vies(-life);

(*gestion de la sortie !!!*)
    if (life<>0) and
     ( (niv(trunc(x) div 16,trunc(y) div 16) in exit_blk)
    or (niv(trunc(x+16) div 16,trunc(y) div 16) in exit_blk)
    or (niv(trunc(x+xsize) div 16,trunc(y) div 16) in exit_blk)
    or (niv(trunc(x) div 16,trunc(y+ysize-1) div 16) in exit_blk)
    or (niv(trunc(x+16) div 16,trunc(y+ysize-1) div 16) in exit_blk)
    or (niv(trunc(x+xsize) div 16,trunc(y+ysize-1) div 16) in exit_blk)
    or (niv(trunc(x) div 16,trunc(y+16) div 16) in exit_blk)
    or (niv(trunc(x) div 16,trunc(y+32) div 16) in exit_blk)
    or (niv(trunc(x+xsize) div 16,trunc(y+16) div 16) in exit_blk)
    or (niv(trunc(x+xsize) div 16,trunc(y+32) div 16) in exit_blk) )
    then begin
      play_wav(wav.clap,100);
      finished:=true;
    end;
  end;
end;

(*position de l'ecran*)
  if cubitus.x+xsize+header.x_anticip>ecran.x+304 then
    if cubitus.x+xsize>header.xmax*16-header.x_anticip then ecran.x:=header.xmax*16-304
    else ecran.x:=cubitus.x-304+header.x_anticip+xsize;
  if cubitus.x-header.x_anticip<ecran.x then
    if cubitus.x<header.x_anticip then ecran.x:=0
    else ecran.x:=cubitus.x-header.x_anticip;
  if cubitus.y+ysize+header.y_anticip>ecran.y+176 then
    if cubitus.y+ysize>header.ymax*16-header.y_anticip then ecran.y:=header.ymax*16-176
    else ecran.y:=cubitus.y-176+header.y_anticip+ysize;
  if cubitus.y-header.y_anticip<ecran.y then
    if cubitus.y<header.y_anticip then ecran.y:=0
    else ecran.y:=cubitus.y-header.y_anticip;
end;

procedure keys;
begin
  case port[$60] of
    35:begin
         repeat until port[$60]<>35;
         half:=not(half);
       end;
    37:vies(-cubitus.life);
    49:nomansux.ok:=true;
    79:finished:=true;
    83:begin
         repeat until port[$60]<>83;
         shit:=not(shit);
         play_wav(wav.shit,98);
       end;
   end;
end;

procedure play;
begin
  repeat
    keys;
    move_objets;
    if cubitus.life=0 then cubitus.y:=cubitus.y-0.7 else  move_cubitus;
    if not(half) or demi then begin
      inc(cmpt_anims);
      make_screen;
     (*copie vers l'cran*)
      waitretrace;
      copypage(temp_pg,scrn_pg);
    end;
    demi:=not(demi);
  until outgame or ((cubitus.life=0) and (cubitus.y-ecran.y<0)) or finished;
end;

procedure theend;
begin
  boxtext('CONGRATULATIONS !');
  freeXMS(BigXMS.handle);
  close_mode13;
  textbackground(red);
  textcolor(white);
  write('                                TU L''AS FAIT !!!                               ');
writeln('                                     (BRAVO)                                     ');
  textbackground(black);
  textcolor(lightgray);
  writeln('C''est bien, tu as fini mon jeu...');
  writeln('Si tu n''as pas utilis les cheats, c''est encore mieux...');
  writeln('De toute manire, si tu est arriv jusqu''ici, c''est que tu as jou ');
  writeln('CUBITUS GAME et c''est dj formidable...');
  writeln('Plus srieusement, il serait gentil de ta part de faire un niveau ou deux et');
  writeln('me les envoyer :-)');
  writeln('CUBITUS vcu heureux et eu beaucoup d''enfants !');
  writeln('ET MAINTENANT, LA FIN !!!');
  BigXMS.offset:=0;
  if existXMS and getXMS(BigXMS.handle,2336) then begin
    writeln('2336 Ko of XMS allocated for the end !');
    fic2XMS(vid.theend,'video\theend.avi');
    fic2XMS(wav.theend,'sounds\theend.wav');
    writeln(BigXMS.offset div 1000+1,' Ko of XMS used for the end !');
    enter;
    init_mode13;
    play_wav(wav.theend,254);
    play_avi(vid.theend,temp_pg,make_pg,320*200);
    close_mode13;
  end else begin
    writeln('Dommage, la vido de fin tait cool...');
    enter;
  end;
  freeXMS(BigXMS.handle);
end;

begin
  init;

  if loadniv then
  repeat
    reload;
    play;
    if cubitus.life=0 then begin
      dec(cubitus.ups);
      boxtext('YOU DIED !!!');
    end;
    if finished then
      if not loadniv then bigend:=true;
  until outgame or (cubitus.ups=0) or bigend;
  if bigend then theend else
  if cubitus.ups=0 then boxtext('GAME OVER !') else
  boxtext('BYE BYE !!!');

  clos;
end.
