
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

unit mode13;

interface
const trnscol=0;
      scrn_pg=ptr($A000,0);
var pal:array [0..767] of byte;
procedure setpal;
procedure init_mode13;
procedure close_mode13;
procedure copypage(source,dest:pointer);
procedure copyflip(source,dest:pointer);
procedure clearpage(page:pointer);
procedure copyblock(x,y:word; source:pointer; xs,ys:word; dest:pointer; xd,yd:word; mask,flip:boolean);
procedure putpixel(page:pointer;x,y:word;col:byte);
procedure waitretrace;
function getpixel(page:pointer; x,y:word):byte;
procedure outtextxy(page:pointer; x,y:word;mot:string;textcol,fondcol:byte);


implementation

procedure init_mode13; assembler;              {initialise le mode 13.}
asm
  mov ax,13h
  int 10h
end;

procedure close_mode13; assembler;
asm
  mov ax,03h
  int 10h
end;

procedure copypage(source,dest:pointer); assembler;
asm
  push ds
  lds si,source
  les di,dest
  mov cx,320*200/4
  db 66h;rep movsw
  pop ds
end;

procedure copyflip(source,dest:pointer); assembler;
asm
  push ds
  lds si,source
  les di,dest
  mov di,320*200
  @boucle:
    sub di,320
    mov cx,320/4
    db 66h;rep movsw
    sub di,320
  jnz @boucle
  pop ds
end;

procedure clearpage(page:pointer); assembler;
asm
  les di,page
  mov cx,03E80h
  db 66h;xor ax,ax
  db 66h;rep stosw
end;

(*procedure copymosa(xs,ys:word; xd,yd:word); assembler;
asm
  push ds

  les di,make_pg
  lds si,brik_pg

  mov ax,yd
  shl ax,6
  add di,ax
  shl ax,2
  add di,ax
  add di,xd

  mov ax,ys
  shl ax,6
  add si,ax
  shl ax,2
  add si,ax
  add si,xs

  mov dx,16                  {met dans le compteur cx la largeur y.}
  @boucle:
    mov cx,4
    db 66h;rep movsw
    add di,320-16
    add si,320-16
    dec dx
  jnz @boucle
  pop ds
end;*)

procedure copyblock(x,y:word; source:pointer; xs,ys:word; dest:pointer; xd,yd:word; mask,flip:boolean); assembler;
asm
  push ds

  cmp x,0
  je @fin
  cmp y,0
  je @fin

  lds si,source
  les di,dest

  mov ax,yd
  shl ax,6
  add di,ax
  shl ax,2
  add di,ax
  add di,xd

  mov ax,ys
  shl ax,6
  add si,ax
  shl ax,2
  add si,ax
  add si,xs

  mov bx,320
  sub bx,x                  {met dans bx le dcalage de fin de ligne.}
  mov cx,y                  {met dans le compteur cx la largeur y.}

  cmp mask,false            {si masque est faux, on saute  la sous-procedure}
  je @sprite                {putsprite...}

@block:
  cmp flip,true
  je @boucle2

  @boucle1:
    push cx
    mov cx,x
    mov dx,cx
    shr cx,2
    db 66h;rep movsw
    mov cx,dx
    and cx,3
    rep movsb
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @boucle1
  jmp @fin

  @boucle2:
  jmp @fin

@sprite:
  cmp flip,false
  je @sprite2

  add di,x
  @sprite1:
    push cx
    mov cx,x
    @line1:
      mov ah,ds:[si]
      or ah,ah
      je @noir1
      cmp ah,85
      je @noir1
      mov es:[di],ah
      @noir1:
      dec di
      inc si
      dec cx
    jnz @line1
    add di,320
    add di,x
    add si,320
    sub si,x
    pop cx
    dec cx
  jnz @sprite1
  jmp @fin

  @sprite2:
    push cx
    mov cx,x
    @line2:
      mov ah,ds:[si]
      or ah,ah
      je @noir2
      cmp ah,85
      je @noir2
      mov es:[di],ah
      @noir2:
      inc di
      inc si
      dec cx
    jnz @line2
    add di,bx
    add si,bx
    pop cx
    dec cx
  jnz @sprite2

  @fin:
  pop ds
end;

procedure putpixel(page:pointer;x,y:word;col:byte); assembler;
asm
 cmp col,trnscol
 jz @transparent
  les di,page
  mov ax,y
  shl ax,6
  mov di,ax
  shl ax,2
  add di,ax
  add di,x
  mov al,col
  mov es:[di],al
 @transparent:
end;

function getpixel(page:pointer; x,y:word):byte; assembler;
asm
  les di,page
  mov ax,y
  shl ax,6
  add di,ax
  shl ax,2
  add di,ax
  add di,x
  mov ax,es:[di]
end;

procedure waitretrace; assembler;
asm
  mov dx,3dah
@wait1:
  in al,dx
  test al,08h
  jnz @wait1
@wait2:
  in al,dx
  test al,08h
  jz @wait2
end;

procedure setpal; assembler;
asm
  cld
  xor di,di
  xor bx,bx
  @l1:
    mov dx,03c8h
    mov ax,bx
    out dx,al
    inc dx
    mov cx,3
    @l2:
      mov al,byte ptr pal[di]
      shr al,1
      shr al,1
      out dx,al
      inc di
    loop @l2
    inc bx
    cmp bx,256
  jne @l1
end;

procedure outtextxy(page:pointer; x,y:word;mot:string;textcol,fondcol:byte);
var m,n,o:byte;
{$i police.inc}
begin
  for m:=1 to length(mot) do
    for n:=1 to 5 do
      for o:=1 to 5 do if lettre[pos(mot[m],liste),o,n]=1 then putpixel(page,x+(m-1)*6+n,y+o,textcol)
      else putpixel(page,x+(m-1)*6+n,y+o,fondcol);
end;

{function saisir(x,y:word; s:string; col:byte):string;
var cc:char;
    t:string;
    nt:integer;
    compt:byte;
begin
  outtextxy(scrn_pg,x,y,s,col,true);
  t:='';
  compt:=0;
  repeat
    cc:=readkey;
    if cc=#0 then begin
      cc:=readkey;
      nt:=1000+ord(cc)
    end
    else nt:=ord(cc);
    case nt of
      8:if compt>0 then begin
        delete(t,compt,1);
        dec(compt);
      end;
      32..255:begin
        inc(compt);
	insert(upcase(chr(nt)),t,compt);
      end;
    end;
    outtextxy(scrn_pg,x+length(s)*6,y,t+' ',col,true);
  until nt=13;
  saisir:=t;
end;}

end.