
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

unit XMS;

INTERFACE
  type fileXMS=record handle:word; offset:longint; end;
  function ExistXMS:boolean;
  function GetXMS(var Handle:word; Size:word):boolean;
  procedure MoveXMS(SHdl:word; SOfs:longint; DHdl:word; Dofs,Size:longint);
  procedure FreeXMS(Handle:word);
  procedure InitXMS;
  var XMSControl:pointer;
  var MoveStruct:record
    Size:longint;
    SHdl:word;
    SOfs:longint;
    DHdl:word;
    DOfs:longint;
  end;
  const struct:pointer=addr(MoveStruct);

IMPLEMENTATION

function ExistXMS:boolean; assembler;
asm
  mov ax,4300h
  int 2Fh
  cmp al,80h
  jne @NoXMSDriver
  mov al,TRUE
  jmp @Done
@NoXMSDriver:
  mov al,FALSE
@Done:
end;

function GetXMS(var Handle:word; Size:word):boolean; assembler;
asm
  mov ah,09h
  mov dx,Size
  call XMSControl
  les di,Handle
  mov es:[di],dx
end;

procedure FreeXMS(Handle:word); assembler;
asm
  mov ah,0Ah
  mov dx,Handle
  call XMSControl
end;

procedure MoveXMS(SHdl:word; SOfs:longint; DHdl:word; DOfs,Size:longint);
begin
  MoveStruct.Size:=Size;
  MoveStruct.SHdl:=SHdl;
  MoveStruct.SOfs:=SOfs;
  MoveStruct.DHdl:=DHdl;
  MoveStruct.DOfs:=DOfs;
  asm
    push ds
    mov ax,ds
    mov es,ax
    mov ah,0Bh
    lds si,Struct
    call es:XMSControl
    pop ds
  end;
end;

procedure InitXMS; assembler;
asm
  mov ax,4310h
  int 2Fh
  mov word ptr [XMSControl],bx
  mov word ptr [XMSControl+2],es
end;

end.
